--*** Texture-mapped cube ***--
--** By Mic, Nov. 1999     **--

without warning

include render.e
include stuff.e
include image.e

sequence points,points2,faces,order,zNormals
sequence tcoords
sequence v,dv	
atom vscreen
atom time1,time2,frames
sequence img,pal

vscreen=allocate(64000)

points2={
 {-1,-1,-1},
 {1,-1,-1},
 {1,1,-1},
 {-1,1,-1},
 {-1,-1,1},
 {1,-1,1},
 {1,1,1},
 {-1,1,1}
}
points2=points2*45

--** Load the texture **--
img=read_bitmap("sdasuka3.bmp")
pal=floor(img[1]/4)
pal[1]={0,0,0}
--** poke the image data into memory **--
img=poke_bitmap(img[2])

--** texture-coordinates for each of the six faces **--
tcoords={
{{0,0},{130,0},{130,195},{0,195}},
{{0,0},{130,0},{130,195},{0,195}},
{{0,0},{130,0},{130,195},{0,195}},
{{130,0},{255,0},{255,195},{130,195}},
{{130,0},{255,0},{255,195},{130,195}},
{{130,0},{255,0},{255,195},{130,195}}
}


--** set mode 19 **--
set_vga()
set_pal(pal)

v={1,1,1}
dv={2,2,2}
frames=0
time1=time()
while get_key()=-1 do
 mem_cls(vscreen,0)
 points=rotate(points2,{1,1,1},v)
  faces={
  points[1..4],
  points[5..8],
  {points[1],points[2],points[6],points[5]},
  {points[6],points[2],points[3],points[7]},
  {points[4],points[3],points[7],points[8]},
  {points[1],points[5],points[8],points[4]}  
 }
 --** Get the z-normals of the faces **--
 zNormals=get_quad_zNormal(faces) 
 order=sort_faces(faces)
 faces=get_screen_xy({160,100},faces)
 for i=1 to 6 do
  --** Is the face visible ? **--
  if zNormals[order[i]]<0 then
   asm_texturequad_ex(faces[order[i]],tcoords[order[i]],img[1],vscreen)
  end if
 end for
 --wait_vrt()
 asm_show_buffer(vscreen)
 frames=frames+1
 v=v+dv
 for i=1 to 3 do
  if v[i]>=361 then
   v[i]=1
  end if
  if v[i]<1 then
   v[i]=360
  end if
 end for
 --** Randomize the rotation **--
 if rand(150)=1 then
  dv=rand({6,6,6})-3
 end if
end while
time2=time()


shut_down()
free(vscreen)
free(img[1])

printf(1,"%d frames per second.\n",floor(frames/(time2-time1)))
